
%bcond_with perl_AnyEvent_enables_Event
%bcond_with perl_AnyEvent_enables_Glib
%bcond_with perl_AnyEvent_enables_POE
%bcond_with perl_AnyEvent_enables_Tk

%global debug_package %{nil}


Name:           perl-AnyEvent
Version:        7.17
Release:    1%{?dist}
Summary:        Framework for multiple event loops
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/AnyEvent
Source0:        https://cpan.metacpan.org/modules/by-module/AnyEvent/AnyEvent-%{version}%{?subver}.tar.gz

BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter >= 5.8.1
BuildRequires:  perl(Canary::Stability)
BuildRequires:  perl(ExtUtils::MakeMaker)

BuildRequires:  perl(B)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Errno)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(Guard)
BuildRequires:  perl(integer)
BuildRequires:  perl(JSON::XS)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(overload)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Socket)
BuildRequires:  perl(Storable)
BuildRequires:  perl(strict)
BuildRequires:  perl(Sys::Syslog)
BuildRequires:  perl(Task::Weaken)
BuildRequires:  perl(Time::HiRes)
BuildRequires:  perl(Unicode::Normalize)

BuildRequires:  perl(File::Spec)
BuildRequires:  perl(Net::SSLeay) >= 1.33
BuildRequires:  perl(Test::More)
BuildRequires:  perl(utf8)
BuildRequires:  perl(warnings)

%if 0%{!?perl_bootstrap:1}
%if %{with perl_AnyEvent_enables_Event}
BuildRequires:  perl(Event)
%endif
%if %{with perl_AnyEvent_enables_Glib}
BuildRequires:  perl(Glib) >= 1.210
%endif
%if %{with perl_AnyEvent_enables_POE}
BuildRequires:  perl(POE) >= 1.312
%endif
%if %{with perl_AnyEvent_enables_Tk}
BuildRequires:  perl(Tk)
%endif
BuildRequires:  perl(AnyEvent::AIO)
BuildRequires:  perl(EV) >= 4.00
BuildRequires:  perl(IO::AIO) >= 4.13
BuildRequires:  perl(IO::Async::Loop) >= 0.33
%endif

Requires:       perl(File::Temp)
Requires:       perl(Guard)
Requires:       perl(Storable)
Requires:       perl(Sys::Syslog)
Requires:       perl(Task::Weaken)
Requires:       perl(Unicode::Normalize)

%global optional_deps                  AnyEvent::AIO
%global optional_deps %{optional_deps}|Cocoa::EventLoop
%global optional_deps %{optional_deps}|EV
%if %{with perl_AnyEvent_enables_Event}
%global optional_deps %{optional_deps}|Event
%endif
%global optional_deps %{optional_deps}|Event::Lib
%global optional_deps %{optional_deps}|EventLoop
%global optional_deps %{optional_deps}|FLTK
%if %{with perl_AnyEvent_enables_Glib}
%global optional_deps %{optional_deps}|Glib
%endif
%global optional_deps %{optional_deps}|IO::AIO
%global optional_deps %{optional_deps}|IO::Async::Loop
%global optional_deps %{optional_deps}|Irssi
%if %{with perl_AnyEvent_enables_POE}
%global optional_deps %{optional_deps}|POE
%endif
%global optional_deps %{optional_deps}|Qt
%global optional_deps %{optional_deps}|Qt::isa
%global optional_deps %{optional_deps}|Qt::slots
%if %{with perl_AnyEvent_enables_Tk}
%global optional_deps %{optional_deps}|Tk
%endif
%global optional_deps %{optional_deps}|UV

%global __requires_exclude ^perl[(](%{optional_deps})[)]

%global __provides_exclude ^perl[(](AnyEvent(::Impl::(Cocoa|FLTK|UV))?|DB)[)]$


%description
AnyEvent provides an identical interface to multiple event loops. This allows
module authors to utilize an event loop without forcing module users to use the
same event loop (as multiple event loops cannot coexist peacefully at any one
time).


%prep
%setup -q -n AnyEvent-%{version}%{?subver}


%build
PERL_CANARY_STABILITY_NOPROMPT=1 perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}
%if !%{with perl_AnyEvent_enables_Event}
rm %{buildroot}%{perl_vendorarch}/AnyEvent/Impl/Event.pm
rm %{buildroot}%{_mandir}/man3/AnyEvent::Impl::Event.3*
%endif
%if !%{with perl_AnyEvent_enables_Glib}
rm %{buildroot}%{perl_vendorarch}/AnyEvent/Impl/Glib.pm
rm %{buildroot}%{_mandir}/man3/AnyEvent::Impl::Glib.3*
%endif
%if !%{with perl_AnyEvent_enables_POE}
rm %{buildroot}%{perl_vendorarch}/AnyEvent/Impl/POE.pm
rm %{buildroot}%{_mandir}/man3/AnyEvent::Impl::POE.3*
%endif
%if !%{with perl_AnyEvent_enables_Tk}
rm %{buildroot}%{perl_vendorarch}/AnyEvent/Impl/Tk.pm
rm %{buildroot}%{_mandir}/man3/AnyEvent::Impl::Tk.3*
%endif


%check
export PERL_ANYEVENT_LOOP_TESTS=1
make test


%files
%license COPYING
%doc Changes README
%{perl_vendorarch}/AE.pm
%{perl_vendorarch}/AnyEvent.pm
%dir %{perl_vendorarch}/AnyEvent/
%{perl_vendorarch}/AnyEvent/constants.pl
%{perl_vendorarch}/AnyEvent/DNS.pm
%{perl_vendorarch}/AnyEvent/Debug.pm
%{perl_vendorarch}/AnyEvent/FAQ.pod
%{perl_vendorarch}/AnyEvent/Handle.pm
%dir %{perl_vendorarch}/AnyEvent/Impl
%{perl_vendorarch}/AnyEvent/Impl/Cocoa.pm
%{perl_vendorarch}/AnyEvent/Impl/EV.pm
%if %{with perl_AnyEvent_enables_Event}
%{perl_vendorarch}/AnyEvent/Impl/Event.pm
%endif
%{perl_vendorarch}/AnyEvent/Impl/EventLib.pm
%{perl_vendorarch}/AnyEvent/Impl/FLTK.pm
%if %{with perl_AnyEvent_enables_Glib}
%{perl_vendorarch}/AnyEvent/Impl/Glib.pm
%endif
%{perl_vendorarch}/AnyEvent/Impl/IOAsync.pm
%{perl_vendorarch}/AnyEvent/Impl/Irssi.pm
%{perl_vendorarch}/AnyEvent/Impl/Perl.pm
%if %{with perl_AnyEvent_enables_POE}
%{perl_vendorarch}/AnyEvent/Impl/POE.pm
%endif
%{perl_vendorarch}/AnyEvent/Impl/Qt.pm
%if %{with perl_AnyEvent_enables_Tk}
%{perl_vendorarch}/AnyEvent/Impl/Tk.pm
%endif
%{perl_vendorarch}/AnyEvent/Impl/UV.pm
%{perl_vendorarch}/AnyEvent/Intro.pod
%{perl_vendorarch}/AnyEvent/IO.pm
%dir %{perl_vendorarch}/AnyEvent/IO
%{perl_vendorarch}/AnyEvent/IO/IOAIO.pm
%{perl_vendorarch}/AnyEvent/IO/Perl.pm
%{perl_vendorarch}/AnyEvent/Log.pm
%{perl_vendorarch}/AnyEvent/Loop.pm
%{perl_vendorarch}/AnyEvent/Socket.pm
%{perl_vendorarch}/AnyEvent/Strict.pm
%{perl_vendorarch}/AnyEvent/TLS.pm
%{perl_vendorarch}/AnyEvent/Util.pm
%dir %{perl_vendorarch}/AnyEvent/Util
%{perl_vendorarch}/AnyEvent/Util/idna.pl
%{perl_vendorarch}/AnyEvent/Util/uts46data.pl
%{_mandir}/man3/AE.3*
%{_mandir}/man3/AnyEvent.3*
%{_mandir}/man3/AnyEvent::DNS.3*
%{_mandir}/man3/AnyEvent::Debug.3*
%{_mandir}/man3/AnyEvent::FAQ.3*
%{_mandir}/man3/AnyEvent::Handle.3*
%{_mandir}/man3/AnyEvent::Impl::Cocoa.3*
%{_mandir}/man3/AnyEvent::Impl::EV.3*
%if %{with perl_AnyEvent_enables_Event}
%{_mandir}/man3/AnyEvent::Impl::Event.3*
%endif
%{_mandir}/man3/AnyEvent::Impl::EventLib.3*
%{_mandir}/man3/AnyEvent::Impl::FLTK.3*
%if %{with perl_AnyEvent_enables_Glib}
%{_mandir}/man3/AnyEvent::Impl::Glib.3*
%endif
%{_mandir}/man3/AnyEvent::Impl::IOAsync.3*
%{_mandir}/man3/AnyEvent::Impl::Irssi.3*
%if %{with perl_AnyEvent_enables_POE}
%{_mandir}/man3/AnyEvent::Impl::POE.3*
%endif
%{_mandir}/man3/AnyEvent::Impl::Perl.3*
%{_mandir}/man3/AnyEvent::Impl::Qt.3*
%if %{with perl_AnyEvent_enables_Tk}
%{_mandir}/man3/AnyEvent::Impl::Tk.3*
%endif
%{_mandir}/man3/AnyEvent::Impl::UV.3*
%{_mandir}/man3/AnyEvent::Intro.3*
%{_mandir}/man3/AnyEvent::IO.3*
%{_mandir}/man3/AnyEvent::IO::IOAIO.3*
%{_mandir}/man3/AnyEvent::IO::Perl.3*
%{_mandir}/man3/AnyEvent::Log.3*
%{_mandir}/man3/AnyEvent::Loop.3*
%{_mandir}/man3/AnyEvent::Socket.3*
%{_mandir}/man3/AnyEvent::Strict.3*
%{_mandir}/man3/AnyEvent::TLS.3*
%{_mandir}/man3/AnyEvent::Util.3*


%changelog
* Wed Jun 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.17-1
- initial build
